#!/usr/bin/php
<?php

ini_set("memory_limit","1024M");
ini_set('error_reporting', E_ALL & ~E_STRICT);

function reader($z, $out = false) {
    echo "\n";
    $sor = "";
    while ($z && !feof($z)) {
        $sor.=fgets($z);
        if (!empty($sor) && ($sor[strlen($sor) - 1] == "]" || $sor[strlen($sor) - 1] == "}")) {
            $co = checkobj($sor);
            if ($co !== FALSE) {
                break;
            }
        }
        usleep(10000);
        //echo ".";
    }
    if ($out) {
        echo "reader:".$sor . "\n";
        logger($sor);
    }
    return $sor;
}

function checkobj($res) {

    $eleje = substr($res, 0, 1000);

    if (preg_match("/([0-9]+):/", $res, $regs)) {

        if (strlen($res) == $regs[1] + strlen($regs[1]) + 1) {
            return json_decode(substr($res, strlen($regs[1]) + 1), true);
        }
    }

    return false;
}

function writer($z, $command, $obj = array()) {
    global $ti;

    if (empty($obj)) {
        $obj = new stdClass();
    }

    if (empty($ti))
        $ti = 0;

    $a = array(0, $ti, $command, $obj);

    $ti++;

    $at = json_encode($a);
    $at = strlen($at) . ":" . $at;



    for ($i=0;$i<strlen($at);$i=$i+1024){
        fwrite($z, substr($at,$i,1024));
        echo "writer:".substr($at,$i,1024) . "\n";
    }

}

$retry = 10;
$timeout = 120;

//max fél percig várunk egy betöltésre, amúgy timeout
ini_set('max_execution_time', 120);
ini_set('default_socket_timeout', 3);
set_time_limit(120);

/*
  paraméterek:
  1: host-ip
  2: host-port
  3: url
 */

if (empty($argv[1])) {
    $argv[1]="localhost";
}

if (empty($argv[2])) {
    $argv[2]="2828";
}

if (empty($argv[3])) {
    $argv[3]="http://creppy.hu";
}

$ip=$argv[1];
echo 'ip:'.$ip."\n";
$port=$argv[2];
echo 'port:'.$port."\n";
$url=$argv[3];
echo 'url:'.$url."\n";

$rtv = 0;
$indult = time();

while ($rtv < $retry) {

    if (time() - $indult >= $timeout) {
        exit;
    }
    $rtv++;
    echo "fsockopen($ip,$port).....\n";
    logger("fsockopen...");
    $z = @fsockopen($ip, $port);
    if ($z) {
        echo "Conn Ok!\n";
        logger("fsockopen: ok");
    }else {
        echo "Conn Err!\n";
        logger("fsockopen: err, sleep(1)");
        sleep(1);
        continue;
    }
    stream_set_blocking($z, false);
    $connOk = reader($z,true);
    
    if (!preg_match("/marionetteProtocol/",$connOk)){

        logger("marionettprotocol error");
        sleep(1);
        continue;
    }
    logger("WebDriver:NewSession");
    
    writer($z, "WebDriver:NewSession", array("acceptInsecureCerts" => true, "capabilities" => array("acceptInsecureCerts" => true)));
    reader($z);
    
    logger("setcontext content");
    writer($z, "Marionette:SetContext", array("value" => "content"));
    reader($z,true);
    
    logger("WebDriver:Navigate");
    writer($z, "WebDriver:Navigate", array("url" => $url));
    reader($z,true);
    
    logger("WebDriver:TakeScreenshot");
    writer($z, "WebDriver:TakeScreenshot", array("full" => true));
    $res = reader($z);
    $var = checkobj($res);
    if ($var !== FALSE) {
        logger("SCHREENSHOT response got!");
        echo "SCHREENSHOT response got!\n";
    }
    if (!empty($var[3]['value'])  ) {
        
        logger("Image string not empty!");
        echo "Image string not empty!\n";
        
        logger("Test PASSED!");
        echo "Test PASSED!\n";
        exit(0);
    }else{
        logger("Error in response, no screenshot: ".json_encode($var));
        echo "Error in response, no screenshot: ".json_encode($var)."\n";
        exit(1);
    }
    
   
}



function logger($log){
global $argv;
    
    $adat='';
    $ip=$argv[1];
    
    $adat.='ip:'.$ip;
    
    $url=$argv[3];
    $adat.=' url:'.$url;
    
    //file_put_contents("/tmp/sclog.log",date("Y-m-d H:i:s")." -> $adat => ".$log."\n",FILE_APPEND);
    
}

?>